Subject: bug#56336: 28.1.90; [28.1] Emacs prompts for password when output from async command contains "password:"

From: Lars Ingebrigtsen <[email-masked]>
Date: Sat, 02 Jul 2022 14:28:34 +0200

Jan Synáček <[email-masked]> writes:

> When the output from a command spawned with 'M-&' (async-shell-command)
> ends with "password:" Emacs prompts for a password.
>
> Reproducer:
> 0) $ cat /tmp/test.txt
>    enter your password:
> 1) emacs -Q
> 2) Press 'M-&', enter 'cat /tmp/test.txt' as input and hit enter.
> 3) Emacs prompts for a password.
>
> I expect that 3) should not happen as the output is simply to stdout and
> no stdin input is expected. Note that the reproducer is minimal and a
> bit contrived but the real bug showed itself when I was running a big
> test suite that contained several lines ending with "password:" in its
> output.
>
> I've also tested this with the latest master (commit
> 3a4c408a7b6f3df5ca0eb4a406efbdb4899e9742), where it sometimes happens as
> well and sometimes you just get an error like this:
>
> Error running timer: (error "Buffer *Async Shell Command* has no process")

I've now fixed the latter in Emacs 29.

The former problem is rather intractable.  That is, if you say

ssh foo@host

you'll get a password prompt as the final line in the buffer, and Emacs
will ask you to enter a password.

If you say

echo -n "password: "; sleep 10; echo foo

then there's no way for Emacs to distinguish that from the ssh
situation: It sees a prompt as the last thing in the buffer, and Emacs
can't possibly know that that's not a process asking for a password.

Note that

echo "password: "; echo foo; sleep 10

won't ask for a password.

So I don't know that there's any way to fix this -- Emacs uses a
heuristic, and it will be wrong in some cases.

Or does anybody have any ideas here?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no